/* --COPYRIGHT--,BSD
 * Copyright (c) 2014, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
//Demo code that uses the Serial Prompt of Energia IDE to program DAC8568 Booster Pack.
//Uses MSP-EXP430F5529LP, go to Tools -> Board to change board type.
//Go to Tools -> Serial Port and select correct Port that MSP is connected to, this is generally shown in Device Manager
//Go to Tools -> Serial Monitor to invoke Serial Prompt
//Launchpad requires a Hardware reset after programming for correct operation.
//  Date   :  June 05, 2016
//  Version:  1.00
//  File   :  BOOST-DAC8568_Interactive.ino


int counter=0;
int Digital=0;
String stringone;
String stringtwo;
int incomingByte = 0;   // for incoming serial data
int acceptableDAC = 0;
unsigned int code;
int mask;
int dacnum;
const int ledPin =  GREEN_LED;      // the number of the LED pin
unsigned int first_Bits_0,first_Bits_1,first_Bits_2,first_Bits_3,first_Bits_4,first_Bits_5,first_Bits_6,first_Bits_7,first_Bits_8,first_Bits_9,first_Bits_10,first_Bits_11,first_Bits_12,first_Bits_13,first_Bits_14,first_Bits_15,first_Bits_16,first_Bits_17,first_Bits_18,first_Bits_19,first_Bits_20,first_Bits_21,first_Bits_22,first_Bits_23,first_Bits_24,first_Bits_25,first_Bits_26,first_Bits_27,first_Bits_28,first_Bits_29,first_Bits_30,first_Bits_31;
unsigned int second_Bits_0,second_Bits_1,second_Bits_2,second_Bits_3,second_Bits_4,second_Bits_5,second_Bits_6,second_Bits_7,second_Bits_8,second_Bits_9,second_Bits_10,second_Bits_11,second_Bits_12,second_Bits_13,second_Bits_14,second_Bits_15,second_Bits_16,second_Bits_17;
unsigned long alltog;        
String query = "";
void setup() {
  pinMode(ledPin, OUTPUT);
  digitalWrite(ledPin, LOW);
  delay(200);
  digitalWrite(ledPin, HIGH);
  delay(200);
  digitalWrite(ledPin, LOW);
  delay(200);
  digitalWrite(ledPin, HIGH);
  delay(200);
  digitalWrite(ledPin, LOW);
  delay(200);
  digitalWrite(ledPin, HIGH);
  delay(200);
  digitalWrite(ledPin, LOW);
  Serial.begin(9600);
  P3DIR |= 0x02;//Initialize Port 3 
  P3SEL = 0x00;
  P3OUT = 0x00; 
  P3OUT = 0x02;
  P4DIR |= 0x04;//Initialize Port 4 
  //P4SEL = 0x00;
  P4OUT = 0x00; 
  P4OUT = 0x04;
  P2DIR |= 0x80;//Initialize Port 2 
  //P2SEL = 0x00;
  P2OUT = 0x02;//Blink LED on Launchpad to notify beginning of program 
  P2OUT = 0x82;
  P3OUT = 0x00;
  P4OUT = 0x04;
  P2OUT = 0x00;
  P2OUT = 0x80;
  P2OUT = 0x00;
  P2OUT = 0x80;
  P2OUT = 0x00;
  P2OUT = 0x80;
  P2OUT = 0x00;
  P2OUT = 0x82;
  P2OUT = 0x02;
  write32(0x0600ffff);
  write32(0x040000ff);
  write32(0x08000001);
  write32(0x03000000);//Set DAC A to 0
  write32(0x03100000);//Set DAC B to 0
  write32(0x03200000);//Set DAC C to 0
  write32(0x03300000);//Set DAC D to 0
  write32(0x03400000);//Set DAC E to 0
  write32(0x03500000);//Set DAC F to 0
  write32(0x03600000);//Set DAC G to 0
  write32(0x03700000);//Set DAC H to 0

  Serial.println("Howdy, before we begin I would like to introduce myself.");
  Serial.println(" "); 

  Serial.println("My name is DAC8568.");
  Serial.println("I am a precision device, allowing you to output any voltage from 0V to 2.5V");
  Serial.println("with 16 bits of resolution resulting in an 38uV LSB step size.");
  Serial.println("But enough about myself, how are you?"); 
  Serial.println("May I ask what your name is?  -- please type in the box above and press ENTER");
  while (Serial.available() == 0) ;  // Wait here until input buffer has a character
  {
    //Side 1
    stringone = Serial.readString();        // 
    Serial.println(" "); 
    Serial.println(" "); 
    Serial.print("Hello "); 
    Serial.print(stringone);
    Serial.println(", it's very nice to meet you!");
  }

  Serial.println(" "); 
  Serial.println("Now let's get started!");
  Serial.println("I have 8 DAC channels, listed A-H.");

}

void loop()
{

  Serial.print("Which DAC channel do you want me to program");
  Serial.print(query);
  Serial.println("? Type from [A-H]");


  while (Serial.available() == 0) ;
  {
    //Side 2
    stringtwo = Serial.readString();
    Serial.println(" ");

    if (stringtwo == "A" | stringtwo == "a"){
      Serial.print("DAC Channel = "); 
      Serial.println(stringtwo);
      dacnum=0;
      acceptableDAC=1;
    }

    if (stringtwo == "B" | stringtwo == "b"){
      Serial.print("DAC Channel = "); 
      Serial.println(stringtwo);
      dacnum=1;
      acceptableDAC=1;

    }

    if (stringtwo == "C" | stringtwo == "c"){
      Serial.print("DAC Channel = "); 
      Serial.println(stringtwo);
      dacnum=2;
      acceptableDAC=1;
    }

    if (stringtwo == "D" | stringtwo == "d"){
      Serial.print("DAC Channel = "); 
      Serial.println(stringtwo);
      dacnum=3;
      acceptableDAC=1;
    }

    if (stringtwo == "E" | stringtwo == "e"){
      Serial.print("DAC Channel = "); 
      Serial.println(stringtwo);
      dacnum=4;
      acceptableDAC=1;
    }

    if (stringtwo == "F" | stringtwo == "f"){
      Serial.print("DAC Channel = "); 
      Serial.println(stringtwo);
      dacnum=5;
      acceptableDAC=1;
    }

    if (stringtwo == "G" | stringtwo == "g"){
      Serial.print("DAC Channel = "); 
      Serial.println(stringtwo);
      dacnum=6;
      acceptableDAC=1;
    }

    if (stringtwo == "H" | stringtwo == "h"){
      Serial.print("DAC Channel = "); 
      Serial.println(stringtwo);
      dacnum=7;
      acceptableDAC=1;
    }    

  }

  Serial.println(" ");
  if (acceptableDAC==1){

    Serial.println("");
    Serial.println("You chose DAC channel:");
    Serial.println(stringtwo);
    Serial.println("");

    if (Digital==0)
      Serial.println("What voltage should I program that output to? -- Pick a value from 0 to 2.5V");
    else
      Serial.println("What digital code should I set? Pick a value from 0 to 65535");


    while (Serial.available() == 0) ;  // Wait here until input buffer has a character
    {
      //Side 1
      stringone = Serial.readString();        // new command in 1.0 forward
      Serial.println(" "); 
      if (Digital==0)
        Serial.print("Desired voltage: "); 
      else
        Serial.print("Desired code: "); 

      Serial.println(stringone);
      Serial.println(" ");
    }

    if (!(Digital) and (stringone.toFloat()>2.5 | stringone.toFloat()<0)){
      Serial.println("Please retry with value within 0 to 2.5V range");
      Serial.println("");
    }
    else{

      if (!Digital){
        code = int(stringone.toFloat()/38.14697265625e-6);
        if (stringone.toFloat()>=2.4999618)
          code = 65535;
      }
      else{
        code=stringone.toInt();
        if (code>65535)
        {
          code = 65535;
          Serial.println("Programmed at maximum code of 65535");
        }

        if (code<0)
        {
          code=0;
          Serial.println("Programmed at minimum code of 0");
        }

      }


      alltog = (0xFFFFFFF & (0x03000000 | (long(code) << 4)))|(long(dacnum) << 20);
      //Serial.println(ctime1, HEX); 
      write32(alltog); 
      //Serial.println(code,HEX);
      acceptableDAC=0;
      Serial.print("Digital code value (HEX): ");
      Serial.println(code,HEX);
      Serial.println("Successfully programed");

      Serial.println("");
      query=" next";
      counter++;

    }



    if (counter ==3){
      Serial.println("I see that you're getting the hang of this.");
      Serial.println("If you wish to find out more information about me please visit the link below");
      Serial.println("http://www.ti.com/product/dac8568");
      Serial.println("");
    }

    if (counter ==5){
      Serial.println("Now that you're more familiar with the hardware let's dive into the essentials of DAC operation.");
      Serial.println("");       
      Serial.println("The number of possible codes of a DAC is defined by the bits/resolution of the device.");
      Serial.println("In this case, I am a 16-bit device, resulting in 2^16 = 65536 codes");
      Serial.println("The voltage step between adjacent codes is referred to as an LSB.");
      Serial.println("In my case, 1 LSB is defined as (Vref/2^n), 2.5V/2^16, which equates to 38uV.");
      Serial.println("The voltage at any digital code is defined as: VOUT= (Digital code) * (2.5V/2^16)");
      Serial.println(""); 
      Serial.println("Now it's time to test your knowledge and input a digital code to get an analog voltage.");
      Serial.println(""); 
      Digital=1;

    }


  }



}



void write32(unsigned long Datawrite) {
  //bitbang SPI, 32bit for DAC8568
  //operations performed beforehand to minimize instructional delay during transaction
  mask = 0x00000001;

  first_Bits_0= ((Datawrite)>>0 & (mask))<<1;
  first_Bits_1= ((Datawrite)>>1 & (mask))<<1;
  first_Bits_2= ((Datawrite)>>2 & (mask))<<1;
  first_Bits_3= ((Datawrite)>>3 & (mask))<<1;
  first_Bits_4= ((Datawrite)>>4 & (mask))<<1;
  first_Bits_5= ((Datawrite)>>5 & (mask))<<1;
  first_Bits_6= ((Datawrite)>>6 & (mask))<<1;
  first_Bits_7= ((Datawrite)>>7 & (mask))<<1;
  first_Bits_8= ((Datawrite)>>8 & (mask))<<1;
  first_Bits_9= ((Datawrite)>>9 & (mask))<<1;
  first_Bits_10= ((Datawrite)>>10 & (mask))<<1;
  first_Bits_11= ((Datawrite)>>11 & (mask))<<1;
  first_Bits_12= ((Datawrite)>>12 & (mask))<<1;
  first_Bits_13= ((Datawrite)>>13 & (mask))<<1;
  first_Bits_14= ((Datawrite)>>14 & (mask))<<1;
  first_Bits_15= ((Datawrite)>>15 & (mask))<<1;
  first_Bits_16= ((Datawrite)>>16 & (mask))<<1;
  first_Bits_17= ((Datawrite)>>17 & (mask))<<1;
  first_Bits_18= ((Datawrite)>>18 & (mask))<<1;
  first_Bits_19= ((Datawrite)>>19 & (mask))<<1;
  first_Bits_20= ((Datawrite)>>20 & (mask))<<1;
  first_Bits_21= ((Datawrite)>>21 & (mask))<<1;
  first_Bits_22= ((Datawrite)>>22 & (mask))<<1;
  first_Bits_23= ((Datawrite)>>23 & (mask))<<1;
  first_Bits_24= ((Datawrite)>>24 & (mask))<<1;
  first_Bits_25= ((Datawrite)>>25 & (mask))<<1;
  first_Bits_26= ((Datawrite)>>26 & (mask))<<1;
  first_Bits_27= ((Datawrite)>>27 & (mask))<<1;
  first_Bits_28= ((Datawrite)>>28 & (mask))<<1;
  first_Bits_29= ((Datawrite)>>29 & (mask))<<1;
  first_Bits_30= ((Datawrite)>>30 & (mask))<<1;
  first_Bits_31= ((Datawrite)>>31 & (mask))<<1;

  P2OUT = 0x82;
  P2OUT = 0x82;

  P2OUT = 0x00;
  P2OUT = 0x00;

  P2OUT = 0x80;
  P2OUT = 0x80;

  P2OUT = 0x00;
  P2OUT = 0x00;

  P4OUT = 0x00; // CS low

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_31;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_30;//Setup data
  P2OUT = 0x00;      

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_29;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_28;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_27;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_26;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_25;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_24;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_23;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_22;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_21;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_20;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_19;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_18;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_17;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_16;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_15;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_14;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_13;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_12;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_11;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_10;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_9;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_8;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_7;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_6;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_5;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_4;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_3;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_2;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_1;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_0;//Setup data
  P2OUT = 0x02;

  P4OUT = 0x04;//CS HIGH

  P3OUT = 0x00;

}

