/* --COPYRIGHT--,BSD
 * Copyright (c) 2014, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
//Hardware: DAC8568 drives NPN transistors which biases 8 Blue LEDs
//Software: Demo code that will slowly light and slowly dim LEDs based on an exponential algorithm
//Lighted LEDs move sequentially from DAC output A to DAC output H 
//Uses MSP-EXP430F5529LP, go to Tools -> Board to change board type.
//Launchpad requires a Hardware reset after programming for correct operation.
//  Date   :  June 05, 2016
//  Version:  1.00
//  File   :  BOOST-DAC8568_LEDFlahs.ino

int first_time = 0;
const int ledPin =  GREEN_LED;      // the number of the LED pin
double new_dig_code = 0;
double new_dig_code2 = 0;
// Variables will change:
int ledState = HIGH;         // the current state of the output pin
int mask;
unsigned int first_Bits_0,first_Bits_1,first_Bits_2,first_Bits_3,first_Bits_4,first_Bits_5,first_Bits_6,first_Bits_7,first_Bits_8,first_Bits_9,first_Bits_10,first_Bits_11,first_Bits_12,first_Bits_13,first_Bits_14,first_Bits_15,first_Bits_16,first_Bits_17,first_Bits_18,first_Bits_19,first_Bits_20,first_Bits_21,first_Bits_22,first_Bits_23,first_Bits_24,first_Bits_25,first_Bits_26,first_Bits_27,first_Bits_28,first_Bits_29,first_Bits_30,first_Bits_31;
unsigned int second_Bits_0,second_Bits_1,second_Bits_2,second_Bits_3,second_Bits_4,second_Bits_5,second_Bits_6,second_Bits_7,second_Bits_8,second_Bits_9,second_Bits_10,second_Bits_11,second_Bits_12,second_Bits_13,second_Bits_14,second_Bits_15,second_Bits_16,second_Bits_17;
int ctime1=0;
int ctime2=0;
float newpat_time = 0;
float oldpat_time = 0;
float nnpat = 0;
float Tau = 0.8;
int first_enter2 = 0;
float stored_code = pow(2,16)-1;

// the following variables are long's because of 32 bit data,
// will quickly become a bigger number than can be stored in an int.
unsigned long alltog;        

void setup() {
  pinMode(ledPin, OUTPUT);
  digitalWrite(ledPin, LOW);
  delay(200);
  digitalWrite(ledPin, HIGH);
  delay(200);
  digitalWrite(ledPin, LOW);
  delay(200);
  digitalWrite(ledPin, HIGH);
  delay(200);
  digitalWrite(ledPin, LOW);
  delay(200);
  digitalWrite(ledPin, HIGH);
  delay(200);
  digitalWrite(ledPin, LOW);
  Serial.begin(9600);
  Serial.println("Initialize");
  P3DIR |= 0x02; 
  P3SEL = 0x00;
  P3OUT = 0x00; 
  P3OUT = 0x02;
  P4DIR |= 0x04; 
  //P4SEL = 0x00;
  P4OUT = 0x00; 
  P4OUT = 0x04;
  P2DIR |= 0x80; 
  //P2SEL = 0x00;
  P2OUT = 0x02; 
  P2OUT = 0x82;
  P3OUT = 0x00;
  P4OUT = 0x04;
  P2OUT = 0x00;
  P2OUT = 0x80;
  P2OUT = 0x00;
  P2OUT = 0x80;
  P2OUT = 0x00;
  P2OUT = 0x80;
  P2OUT = 0x00;
  P2OUT = 0x82;
  P2OUT = 0x02;
  write32(0x0600ffff);
  write32(0x040000ff);
  write32(0x08000001);
  write32(0x03000000);//Set DAC A to 0
  write32(0x03100000);//Set DAC B to 0
  write32(0x03200000);//Set DAC C to 0
  write32(0x03300000);//Set DAC D to 0
  write32(0x03400000);//Set DAC E to 0
  write32(0x03500000);//Set DAC F to 0
  write32(0x03600000);//Set DAC G to 0
  write32(0x03700000);//Set DAC H to 0
  oldpat_time=millis();

}

void loop() {
  //Serial.println("Event1"); 
  Tau = 0.8; 
  newpat_time = millis() - oldpat_time;//measuring elapsed time
  nnpat = -(1/Tau) * ((newpat_time)/1000);//Tau is estimated time for charge and discharge characteristic       
  nnpat = expf(nnpat);  
  if (newpat_time < Tau*2000){
    new_dig_code2 = stored_code * (1 - nnpat);//exponential increase to FS
    new_dig_code = (stored_code * nnpat);//exponentioal decrease to FS
    if (ctime1>7)
      ctime1=0;
    alltog = (0xFFFFFFF & (0x03000000 | (long(new_dig_code) << 4)))| (long(ctime1) << 20);
    write32(alltog);
    if (ctime1 ==7){
      ctime2=-1;
    }
    else{
      ctime2 =ctime1;
    }
    alltog = (0xFFFFFFF & (0x03000000 | (long(new_dig_code2) << 4)))|(long(ctime2+1) << 20);
    //Serial.println(ctime1, HEX); 
    write32(alltog); 
  }
  else{
    oldpat_time = millis();
    first_enter2 = 0;
    stored_code = pow(2,16)-1;
    ctime1++;
  }
  delay(10);


}

void write32(unsigned long Datawrite) {
//bitbang SPI, 32bit for DAC8568
//operations performed beforehand to minimize instructional delay during transaction
  mask = 0x00000001;

  first_Bits_0= ((Datawrite)>>0 & (mask))<<1;
  first_Bits_1= ((Datawrite)>>1 & (mask))<<1;
  first_Bits_2= ((Datawrite)>>2 & (mask))<<1;
  first_Bits_3= ((Datawrite)>>3 & (mask))<<1;
  first_Bits_4= ((Datawrite)>>4 & (mask))<<1;
  first_Bits_5= ((Datawrite)>>5 & (mask))<<1;
  first_Bits_6= ((Datawrite)>>6 & (mask))<<1;
  first_Bits_7= ((Datawrite)>>7 & (mask))<<1;
  first_Bits_8= ((Datawrite)>>8 & (mask))<<1;
  first_Bits_9= ((Datawrite)>>9 & (mask))<<1;
  first_Bits_10= ((Datawrite)>>10 & (mask))<<1;
  first_Bits_11= ((Datawrite)>>11 & (mask))<<1;
  first_Bits_12= ((Datawrite)>>12 & (mask))<<1;
  first_Bits_13= ((Datawrite)>>13 & (mask))<<1;
  first_Bits_14= ((Datawrite)>>14 & (mask))<<1;
  first_Bits_15= ((Datawrite)>>15 & (mask))<<1;
  first_Bits_16= ((Datawrite)>>16 & (mask))<<1;
  first_Bits_17= ((Datawrite)>>17 & (mask))<<1;
  first_Bits_18= ((Datawrite)>>18 & (mask))<<1;
  first_Bits_19= ((Datawrite)>>19 & (mask))<<1;
  first_Bits_20= ((Datawrite)>>20 & (mask))<<1;
  first_Bits_21= ((Datawrite)>>21 & (mask))<<1;
  first_Bits_22= ((Datawrite)>>22 & (mask))<<1;
  first_Bits_23= ((Datawrite)>>23 & (mask))<<1;
  first_Bits_24= ((Datawrite)>>24 & (mask))<<1;
  first_Bits_25= ((Datawrite)>>25 & (mask))<<1;
  first_Bits_26= ((Datawrite)>>26 & (mask))<<1;
  first_Bits_27= ((Datawrite)>>27 & (mask))<<1;
  first_Bits_28= ((Datawrite)>>28 & (mask))<<1;
  first_Bits_29= ((Datawrite)>>29 & (mask))<<1;
  first_Bits_30= ((Datawrite)>>30 & (mask))<<1;
  first_Bits_31= ((Datawrite)>>31 & (mask))<<1;

  P2OUT = 0x82;
  P2OUT = 0x82;

  P2OUT = 0x00;
  P2OUT = 0x00;

  P2OUT = 0x80;
  P2OUT = 0x80;

  P2OUT = 0x00;
  P2OUT = 0x00;

  P4OUT = 0x00; // CS low

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_31;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_30;//Setup data
  P2OUT = 0x00;      

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_29;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_28;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_27;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_26;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_25;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_24;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_23;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_22;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_21;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_20;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_19;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_18;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_17;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_16;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_15;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_14;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_13;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_12;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_11;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_10;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_9;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_8;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_7;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_6;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_5;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_4;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_3;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_2;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_1;//Setup data
  P2OUT = 0x00;

  P2OUT = 0x80;
  P3OUT = 0x00 | first_Bits_0;//Setup data
  P2OUT = 0x02;

  P4OUT = 0x04;//CS HIGH

  P3OUT = 0x00;

}


